//Air Wick
//  Mikro C




 #define  SensorPower GPIO.GP0 //
  #define  LDRin    GPIO.GP1 //  Light Dependent Resistors (LDR) to comparator
  #define LED GPIO.GP4
  #define Mode GPIO.GP3
  #define Button GPIO.GP2
  #define Motor GPIO.GP5

   #define Sensor_On  SensorPower = 1
   #define Sensor_Off  SensorPower = 0

   #define Motor_On  Motor = 1
   #define Motor_Off  Motor = 0

   #define LED_On  LED = 1
   #define LED_Off  LED = 0

 #define Light !CMCON.COUT

 #define Cvref_On VRCON =  0b10001000//   comparator voltage reference ON Vdd(3V)/2 =  1.5V
 #define Cvref_Off VRCON = 0 //   comparator voltage reference  Off
 //   comparator voltage reference
                 //bit 7 =  1 VREN Vref is on
                 //bit 6 = 0 unimplemented
                 //bit5  =0  VRR    high range
                 //bit4  = 0 unimplemented
                 //bit3  =  1   VR3:VR0: CVREF value selection 0 . VR [3:0] . 15
                 //bit2  =  0    When VRR = 1: CVREF = (VR3:VR0 / 24) * VDD
                 //bit1  =  0   When VRR = 0: CVREF = VDD/4 + (VR3:VR0 / 32) * VDD
                 //bit0  =   0
                 
                 
                 
 #define Comparator_On CMCON = 4//0b100
 #define Comparator_Off CMCON = 7//0b111

 enum Modes {Usual = 0, Guests };

   unsigned  char LedCounter ; //1 byte
   unsigned long  LightOnTime;// 4 byte
   unsigned long  LightOffTime;// 4 byte
   unsigned long  MotorOnTime;// 4 byte
   unsigned long  MotorOffTime;// 4 byte
   unsigned  char Step;

   volatile unsigned  char GPRead;

   char PE;
   char NE;

   char OldState;
   char CurrentState;


  #define IO 0x0E

 



    void ClearVars ()
   {
        LightOnTime=0;
        LightOffTime=0;
        MotorOnTime=0;
    }




    void PeriphOn ()
    {     //  ,   
               Cvref_On;
               Sensor_On;
               Comparator_On;

 
              Delay_ms (1);
    }




        void PeriphOff ()
    {           // 

                   Cvref_Off;
                   Sensor_Off;
                   Comparator_Off;
                   LED_Off;
                   Motor_Off;

    }






void interrupt()
{

         if (INTCON.GPIF == 1)//timer0 overflow wlag
      {
       //return;
      INTCON.GPIF =0;
       }



      if (INTCON.T0IF == 1)//timer0 overflow wlag
      {
       INTCON.T0IF =0;

       //return;

       }


    if (PIR1.TMR1IF == 1)//timer1 overflow wlag
      {
           PIE1.TMR1IE = 0; //disable this interrupt

          //LED flashing
       LedCounter++;
       if (LedCounter>250 && Step==1) { LED_On ;}  //   
       else { LED_Off ;}



                             if (Step==1)
                             {
                                  if (Light)
                                  {
                                     LightOnTime++;//  
                                   }
                                  else
                                  {
                                      if ( LightOnTime > 18000 &&  LightOnTime < 90000 )  //3 to 15 min
                                      {
                                         Step=2;
                                       }
                                      else
                                      {
                                        ClearVars ();
                                       Step=0;

                                      }
                                  }

                             }



                            if (Step==2)
                            {
                                  if (Light)
                                  {
                                   Step=3;
                                   }
                                   else
                                   {
                                       if ( LightOffTime > 180000)//over 30 min
                                        {
                                             ClearVars ();
                                             Step=0;
                                        }
                                        else
                                        {
                                             LightOffTime++;//  
                                        }
                                   }
                            }


                            if (Step==3)
                            {
                                 MotorOnTime++;
                                 if ( MotorOnTime < 100)    //1 sec
                                   {
                                     Motor_On;//    1
                                     }
                                  else
                                 {  Motor_Off;
                                    ClearVars ();
                                    Step=0;
                                   }
                            }
                            else
                            {
                              Motor_Off;
                            }

      //10000 tick -> 0.01sec -> 65535 - 10000 = 55535 -> D8 EF hex in tmr1
        TMR1H = 0xD8;
        TMR1L = 0xEF;

        PIR1.TMR1IF = 0; //reset flag
        PIE1.TMR1IE = 1;   //enable this interrupt
        //return;
       }


    if (INTCON.INTF == 1)//GP2/INT  wlag
      {
          if (Button==1)
         {
             Step=3; //motor   on
         }

       INTCON.INTF =0;
        //  return;

       }

    return;
}






 main  ( )//

{
 
    TRISIO     =    0b11111;
    GPIO=0;
    
    asm   {clrwdt}  ;
     Delay_ms (1000);  //wait (100000);//1sek   
    asm   {clrwdt}  ;
     Delay_ms (1000);// wait (100000);//1sek
    asm   {clrwdt}  ;
     Delay_ms (1000);// wait (100000);//1sek
     //////////////////////////////////////////
     


 
TRISIO = IO;
GPIO=0;
   CMCON = 7;           //00000111 disable comparator
  


  ClearVars ();
   MotorOffTime=0;
   Step=0;

   PE=0;
   NE=0;
   OldState=0;
   CurrentState=0;


while (1)

{


    //initialization of registers


   T1CON = 0;            // TMR1
              //0 unimplemented
               //TMR1GE=0
               //0 T1CKPS0
               //0 T1CKPS0 prescaller=1:1
               //T1OSCEN=0 LP oscillator disabled
               //T1SYNC=0
               //TMR1CS = 0 internal clock
               //TMR1ON=0 timer DISabled



  TRISIO = IO;    //000100b 1-input; 0 - output 4
                 //GP5    0
                 //GP4   0
                 //GP3 - 0
                 //GP2 - 1 input button
                 //GP1 - 0 output to relay
                 //GP0   0


        T1CON = 5;            // TMR1
              //0 unimplemented
               //TMR1GE=0
               //0 T1CKPS0
               //0 T1CKPS0 prescaller=1:1
               //T1OSCEN=0 LP oscillator disabled
               //T1SYNC=1   async mode
               //TMR1CS = 0 internal clock
               //TMR1ON=1 timer enabled

  WPU=0;//pill-ups disabled

   //IOC=0;//interrupt on change GPIO disabled



      OPTION_REG = 0x4F; //initializing OPTION register 10001111b;

                     // GPPU=0 internal loads of port GPIO disabled
                     // INTEDG=1 interrupt on rising edge on pin INT GP2
                     // T0SC=0 RTCC connected to internal source
                    // T0SE=0 RTCC increments by positive front
                    // PSA=1 prescaller is connected to WDT
                    // PS2=1
                    // PS1=1  switch WDT to prescaller 1:128.
                     // PS0=1



    PIE1=0x00;
              //EEIE = 0;disable EEPROM write completed interrupt
              //ADIE=0 ADC disabled (for 12F675)
              //0 unimplemented
              //0 unimplemented
              //CMIE=0 comparator interr disabled
              //0 unimplemented
              //0 unimplemented
              //TMR1IE = 0 disable TMR1 overflow interrupt


  //  INTCON=0x00;
              //GIE = 0;disable interrupt
              //PEIE=0 peripheral interrupt disabled
              //T0IE=0 overlow TMR0 interr disabled
              //INTE=0 external interrupt GP2/INT disabled
              //GPIE=0 portGP changing interr disabled
              //T0IF FLAG( 1 -TMR0 has overflow . Must be cleaned in software;  0 -TMR0 register did not overflow)
              //INTF FLAG(1 - GP2/INT external interrupt occurred. Must be cleaned in software; 0 -not occureed)
              //GPIF FLAG (1-port GP5:GP0 pin was changed.  Must be cleaned in software)



    INTCON.PEIE=1; //peripheral interrupt enabled





             PIE1=0x01;
              //EEIE = 0;disable EEPROM write completed interrupt
              //ADIE=0 ADC disabled (for 12F675)
              //0 unimplemented
              //0 unimplemented
              //CMIE=0 comparator interr disabled
              //0 unimplemented
              //0 unimplemented
              //TMR1IE = 1 enable TMR1 overflow interrupt


      PIE1.TMR1IE = 1;   //then ena TMR1 interrupt
        INTCON.INTE=1; //external interrupt GP2/INT enabled
       INTCON.GIE = 1;  //ena global interrupt



asm   {clrwdt}  ;


       //  WDT
       //  ,   
       PeriphOn ();
                  
                  
     if (Mode == Usual)
     {
          if (Step == 0) //    WDT   
           {


                if (Light) //  
                {
                     Step=1;
                 }
                 else
                 {

                      if (Motor==0)//    
                      {
                          // 
                          PeriphOff ();


                          asm {sleep} ;
                          asm { nop };
                        }
                   }
           }
        }

        else//Mode==Guests
        {
                  NE=0;
                  PE=0;

                  if (Step== 0)
                  {     if (Light == 1 && OldState == 0) {PE=1; Step = 3;}
                        if (Light == 0 && OldState == 1) {NE=1; Step = 3;}

                        CurrentState = Light;  //     

                                          if (!PE && !NE)
                                               {
                                                  if (Motor==0)//    
                                                    {
                                                      // 
                                                      PeriphOff ();

                                                      asm {sleep} ;
                                                       asm { nop };
                                                      }
                                            }
                  }


                  OldState = CurrentState;//

        }

         if (Step!=3) Motor_Off;

}

}
